// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#include<LINK/graph/Vertex.h>
#include<LINK/graph/Graph.h>
#include<LINK/graph/DBinGraph.h>
#include<LINK/graph/UBinGraph.h>
#include<LINK/graph/UHyperGraph.h>
#include<LINK/basic/Sequence.h>

MDBinGraph* GenLatkaTournament(int, int);
MUBinGraph* GenCycle(int);
MUBinGraph* GenRandomGraph(int,double);
MUBinGraph* GenCompleteGraph(int);
MUBinGraph* GenGraphFromLinearOrders(int, Set<int>);
void        UpdateLinearOrdersGraph(Graph*, Set<int>);
MUBinGraph* GenGridGraph(int, int);
MUBinGraph* GenHalinGraph(Graph *);
MUBinGraph* GenPrufer(int, Sequence<int>);
MUBinGraph* GenPrufer(char *);
MUBinGraph* GenRegularGraph(int, int);
MUHyperGraph* GenUHyperGraphKU(int, int, int);
